<DOCFLEX_TEMPLATE VER='1.13'>
CREATED='2005-08-07 07:34:00'
LAST_UPDATE='2009-10-30 06:36:30'
DESIGNER_TOOL='DocFlex SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='docflex-xml-xsddoc2'
APP_NAME='DocFlex/XML XSDDoc'
APP_VER='2.2.0'
APP_AUTHOR='Copyright \u00a9 2005-2009 Filigris Works,\nLeonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='xsddoc'
ROOT_ETS={'xs:%complexType';'xs:%simpleType'}
<TEMPLATE_PARAMS>
	PARAM={
		param.name='deriv.simpleContent';
		param.title='Simple Content Derivation';
		param.grouping='true';
		param.type='enum';
		param.enum.values='local;full;none';
	}
	PARAM={
		param.name='deriv.simpleContent.facets';
		param.title='Facets';
		param.type='boolean';
	}
	PARAM={
		param.name='deriv.simpleContent.annotations';
		param.title='Annotations';
		param.type='boolean';
	}
	PARAM={
		param.name='fmt.allowNestedTables';
		param.title='Allow nested tables';
		param.type='boolean';
		param.default.value='true';
	}
</TEMPLATE_PARAMS>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs7';
}
<STYLES>
	CHAR_STYLE={
		style.name='Annotation';
		style.id='cs1';
		text.font.name='Arial';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Annotation Smaller';
		style.id='cs2';
		text.font.name='Arial';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Annotation Smallest';
		style.id='cs3';
		text.font.name='Arial';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Code Smaller';
		style.id='cs4';
		text.font.name='Courier New';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs5';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Derivation Method';
		style.id='cs6';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#FF9900';
	}
	PAR_STYLE={
		style.name='Detail Heading 5';
		style.id='s1';
		text.font.name='Arial';
		text.font.size='8';
		text.font.style.bold='true';
		text.font.style.italic='true';
		text.color.background='#CCCCFF';
		text.color.opaque='true';
		par.margin.top='8';
		par.margin.bottom='8';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs7';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='s2';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Normal Smaller';
		style.id='cs8';
		text.font.name='Arial';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Normal Smallest';
		style.id='cs9';
		text.font.name='Arial';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Property Text';
		style.id='cs10';
		text.font.name='Verdana';
		text.font.size='8';
		par.lineHeight='11';
	}
	PAR_STYLE={
		style.name='Property Title';
		style.id='s3';
		text.font.name='Arial';
		text.font.size='8';
		text.font.style.bold='true';
		par.lineHeight='11';
		par.margin.right='7';
	}
	PAR_STYLE={
		style.name='Property Value';
		style.id='s4';
		text.font.name='Verdana';
		text.font.size='8';
		par.lineHeight='11';
	}
</STYLES>
<ROOT>
	<SS_CALL>
		MATCHING_ET='xs:%simpleType'
		BREAK_PARENT_BLOCK='when-executed'
		SS_NAME='simpleType'
	</SS_CALL>
	<SS_CALL>
		MATCHING_ET='xs:%complexType'
		SS_NAME='complexType'
	</SS_CALL>
</ROOT>
<STOCK_SECTIONS>
	<FOLDER>
		MATCHING_ET='xs:%annotated'
		SS_NAME='annotation'
		<BODY>
			<TEMPLATE_CALL>
				FMT={
					par.lineHeight='0';
				}
				TEMPLATE_FILE='../ann/annotation.tpl'
			</TEMPLATE_CALL>
		</BODY>
	</FOLDER>
	<ELEMENT_ITER>
		DESCR='this should be a complexType with simple content only'
		MATCHING_ET='xs:%complexType'
		TARGET_ETS={'xs:extension%xs:simpleExtensionType';'xs:restriction%xs:simpleRestrictionType'}
		SCOPE='advanced-location-rules'
		RULES={
			'* -> xs:simpleContent/(xs:extension|xs:restriction)';
		}
		SS_NAME='complexType'
		<BODY>
			<SS_CALL>
				DESCR='process the restriction contained in it'
				MATCHING_ET='xs:restriction%xs:simpleRestrictionType'
				BREAK_PARENT_BLOCK='when-executed'
				SS_NAME='restriction'
			</SS_CALL>
			<SS_CALL>
				DESCR='process the extension contained in it'
				MATCHING_ET='xs:extension%xs:simpleExtensionType'
				SS_NAME='extension'
			</SS_CALL>
		</BODY>
	</ELEMENT_ITER>
	<FOLDER>
		MATCHING_ETS={'xs:%simpleExtensionType';'xs:%simpleRestrictionType';'xs:list';'xs:restriction';'xs:union'}
		SS_NAME='Derivation Method'
		<BODY>
			<FOLDER>
				MATCHING_ET='xs:%simpleExtensionType'
				FMT={
					text.style='cs10';
				}
				<BODY>
					<AREA_SEC>
						COND='getAttrValue("base") != null'
						BREAK_PARENT_BLOCK='when-executed'
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='extension of'
									</LABEL>
									<DATA_CTRL>
										FMT={
											text.style='cs4';
										}
										<DOC_HLINK>
											HKEYS={
												'qName = getAttrQNameValue("base");\n\nfindElementByKey (\n  "types",\n  hasServiceAttr ("redefined") ?\n    HashKey (qName, getServiceAttr ("redefined")) : qName\n).id';
												'Array ("detail", "xml-source-location")',array;
											}
										</DOC_HLINK>
										FORMULA='getAttrQNameValue("base").toXMLName()'
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='extension of'
									</LABEL>
									<DATA_CTRL>
										FMT={
											text.style='cs4';
										}
										FORMULA='toXMLName (getNamespaceURI("xs"), "anySimpleType")'
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
			<FOLDER>
				MATCHING_ETS={'xs:%simpleRestrictionType';'xs:restriction'}
				FMT={
					text.style='cs10';
				}
				<BODY>
					<AREA_SEC>
						COND='getAttrValue("base") != null'
						BREAK_PARENT_BLOCK='when-executed'
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='restriction of'
									</LABEL>
									<DATA_CTRL>
										FMT={
											text.style='cs4';
										}
										<DOC_HLINK>
											HKEYS={
												'qName = getAttrQNameValue("base");\n\nfindElementByKey (\n  "types", \n  hasServiceAttr ("redefined") ?\n    HashKey (qName, getServiceAttr ("redefined")) : qName\n).id';
												'Array ("detail", "xml-source-location")',array;
											}
										</DOC_HLINK>
										FORMULA='getAttrQNameValue("base").toXMLName()'
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='restriction of'
									</LABEL>
									<LABEL>
										TEXT='anonymous'
									</LABEL>
									<LABEL>
										TEXT='simpleType'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
			<FOLDER>
				MATCHING_ET='xs:list'
				FMT={
					text.style='cs10';
				}
				<BODY>
					<AREA_SEC>
						COND='getAttrValue("itemType") != null'
						BREAK_PARENT_BLOCK='when-executed'
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='list of'
									</LABEL>
									<DATA_CTRL>
										FMT={
											text.style='cs4';
										}
										<DOC_HLINK>
											HKEYS={
												'findElementByKey ("types", getAttrQNameValue("itemType")).id';
												'Array ("detail", "xml-source-location")',array;
											}
										</DOC_HLINK>
										FORMULA='getAttrQNameValue("itemType").toXMLName()'
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='list of'
									</LABEL>
									<LABEL>
										TEXT='anonymous'
									</LABEL>
									<LABEL>
										TEXT='simpleType'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
			<FOLDER>
				MATCHING_ET='xs:union'
				FMT={
					txtfl.delimiter.type='text';
					txtfl.delimiter.text=' | ';
				}
				<BODY>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.delimiter.type='space';
								}
								<CTRLS>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='by union'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
			<SS_CALL>
				COND='getBooleanParam("deriv.simpleContent.annotations")'
				FMT={
					sec.spacing.before='8';
					sec.spacing.after='6';
					text.style='cs3';
				}
				SS_NAME='annotation'
			</SS_CALL>
		</BODY>
	</FOLDER>
	<FOLDER>
		MATCHING_ET='xs:%simpleExtensionType'
		SS_NAME='extension'
		<BODY>
			<FOLDER>
				FMT={
					sec.outputStyle='table';
					table.cellpadding.both='0';
					table.border.style='none';
				}
				<BODY>
					<AREA_SEC>
						FMT={
							trow.align.vert='Top';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='63';
											ctrl.size.height='17.3';
											par.style='s3';
										}
										TEXT='Derivation:'
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											ctrl.size.width='436.5';
											ctrl.size.height='17.3';
											par.style='s4';
										}
										SS_NAME='Derivation Method'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
			<FOLDER>
				DESCR='derivation of referenced base type'
				COND='getAttrValue("base") != null &&\nhasParamValue("deriv.simpleContent", "full")'
				CONTEXT_ELEMENT_EXPR='typeQName = getAttrQNameValue("base");\n\nisXSPredefinedType (typeQName) ? null :\n{\n  setVar ("typeQName", typeQName);\n\n  findElementByKey (\n    "types",\n    hasServiceAttr ("redefined") ?\n      HashKey (typeQName, getServiceAttr ("redefined")) : typeQName\n  )\n}'
				MATCHING_ETS={'xs:complexType';'xs:simpleType'}
				FMT={
					sec.indent.block='true';
				}
				<BODY>
					<SS_CALL>
						COND='getBooleanParam("deriv.simpleContent.annotations")'
						FMT={
							sec.spacing.after='6';
							text.style='cs3';
						}
						SS_NAME='annotation'
					</SS_CALL>
					<SS_CALL>
						MATCHING_ET='xs:simpleType'
						BREAK_PARENT_BLOCK='when-executed'
						SS_NAME='simpleType'
					</SS_CALL>
					<SS_CALL>
						MATCHING_ET='xs:complexType'
						SS_NAME='complexType'
					</SS_CALL>
				</BODY>
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='s1';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<DATA_CTRL>
										FORMULA='\'"\' + getVar("typeQName") + \'"\''
									</DATA_CTRL>
									<LABEL>
										MATCHING_ET='xs:simpleType'
										TEXT='simpleType'
									</LABEL>
									<LABEL>
										MATCHING_ET='xs:complexType'
										TEXT='complexType'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
			</FOLDER>
		</BODY>
	</FOLDER>
	<FOLDER>
		MATCHING_ET='xs:%facet'
		SS_NAME='Facet'
		<BODY>
			<TEMPLATE_CALL>
				TEMPLATE_FILE='facet.tpl'
				PASSED_PARAMS={
					'facet.annotation','getBooleanParam("deriv.simpleContent.annotations")';
				}
			</TEMPLATE_CALL>
		</BODY>
	</FOLDER>
	<ELEMENT_ITER>
		MATCHING_ETS={'xs:%restrictionType';'xs:restriction'}
		FMT={
			sec.outputStyle='table';
			table.cellpadding.both='0';
			table.border.style='none';
		}
		TARGET_ET='xs:%facet'
		SCOPE='simple-location-rules'
		RULES={
			'* -> xs:%facet';
		}
		FILTER_BY_KEY='// eliminate multiple instanceof of <enumeration>\n\ninstanceOf("xs:enumeration") ? 1 : contextElement.id'
		SORTING='by-expr'
		SORTING_KEY={expr='contextElement.dsmElement.qName.localName',ascending}
		SS_NAME='Facets'
		<BODY>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<DATA_CTRL>
								FMT={
									ctrl.size.width='105';
									ctrl.size.height='17.3';
									tcell.align.vert='Top';
									tcell.option.nowrap='true';
									par.style='s3';
								}
								FORMULA='contextElement.dsmElement.qName.localName + \':\''
							</DATA_CTRL>
							<SS_CALL_CTRL>
								FMT={
									ctrl.size.width='394.5';
									ctrl.size.height='17.3';
									tcell.align.vert='Bottom';
									tcell.padding.extra.top='0.5';
								}
								SS_NAME='Facet'
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</ELEMENT_ITER>
	<FOLDER>
		MATCHING_ETS={'xs:%simpleRestrictionType';'xs:restriction'}
		SS_NAME='restriction'
		<BODY>
			<FOLDER>
				FMT={
					sec.outputStyle='table';
					table.cellpadding.both='0';
					table.border.style='none';
				}
				<BODY>
					<AREA_SEC>
						FMT={
							trow.align.vert='Top';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='63';
											ctrl.size.height='17.3';
											par.style='s3';
										}
										TEXT='Derivation:'
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											ctrl.size.width='436.5';
											ctrl.size.height='17.3';
											par.style='s4';
										}
										SS_NAME='Derivation Method'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<FOLDER>
						DESCR='facets'
						COND='getBooleanParam("deriv.simpleContent.facets") &&\nhasChild("xs:%facet")'
						<BODY>
							<AREA_SEC>
								COND='getBooleanParam("fmt.allowNestedTables")'
								FMT={
									trow.align.vert='Top';
								}
								BREAK_PARENT_BLOCK='when-executed'
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='63';
													ctrl.size.height='17.3';
													par.style='s3';
													par.lineHeight='13';
												}
												TEXT='Facets:'
											</LABEL>
											<SS_CALL_CTRL>
												FMT={
													ctrl.size.width='436.5';
													ctrl.size.height='17.3';
													tcell.align.vert='Bottom';
													tcell.padding.extra.top='0.5';
												}
												SS_NAME='Facets'
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
							<ELEMENT_ITER>
								DESCR='when nested tables are not allowed'
								TARGET_ET='xs:%facet'
								SCOPE='simple-location-rules'
								RULES={
									'* -> xs:%facet';
								}
								FILTER_BY_KEY='// eliminate multiple instanceof of <enumeration>\n\ninstanceOf("xs:enumeration") ? 1 : contextElement.id'
								SORTING='by-expr'
								SORTING_KEY={expr='contextElement.dsmElement.qName.localName',ascending}
								<BODY>
									<AREA_SEC>
										COND='iterator.isFirstItem'
										FMT={
											trow.align.vert='Top';
										}
										BREAK_PARENT_BLOCK='when-executed'
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<LABEL>
														FMT={
															ctrl.size.width='63';
															ctrl.size.height='17.3';
															par.style='s3';
														}
														TEXT='Facets:'
													</LABEL>
													<DATA_CTRL>
														FMT={
															ctrl.size.width='72';
															ctrl.size.height='17.3';
															tcell.option.nowrap='true';
															par.style='s3';
														}
														FORMULA='contextElement.dsmElement.qName.localName + \':\''
													</DATA_CTRL>
													<SS_CALL_CTRL>
														FMT={
															ctrl.size.width='364.5';
															ctrl.size.height='17.3';
															tcell.align.vert='Bottom';
															tcell.padding.extra.top='0.5';
														}
														SS_NAME='Facet'
													</SS_CALL_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
									<AREA_SEC>
										FMT={
											trow.align.vert='Top';
										}
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<LABEL>
														FMT={
															ctrl.size.width='63';
															ctrl.size.height='17.3';
															par.style='s3';
														}
														TEXT=''
													</LABEL>
													<DATA_CTRL>
														FMT={
															ctrl.size.width='72';
															ctrl.size.height='17.3';
															tcell.option.nowrap='true';
															par.style='s3';
														}
														FORMULA='contextElement.dsmElement.qName.localName + \':\''
													</DATA_CTRL>
													<SS_CALL_CTRL>
														FMT={
															ctrl.size.width='364.5';
															ctrl.size.height='17.3';
															tcell.align.vert='Bottom';
															tcell.padding.extra.top='0.5';
														}
														SS_NAME='Facet'
													</SS_CALL_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
								</BODY>
							</ELEMENT_ITER>
						</BODY>
					</FOLDER>
				</BODY>
			</FOLDER>
			<FOLDER>
				DESCR='derivation of referenced base type'
				COND='getAttrValue("base") != null &&\nhasParamValue("deriv.simpleContent", "full")'
				CONTEXT_ELEMENT_EXPR='typeQName = getAttrQNameValue("base");\n\nisXSPredefinedType (typeQName) ? null :\n{\n  setVar ("typeQName", typeQName);\n\n  findElementByKey (\n    "types",\n    hasServiceAttr ("redefined") ?\n      HashKey (typeQName, getServiceAttr ("redefined")) : typeQName\n  )\n}'
				MATCHING_ETS={'xs:complexType';'xs:simpleType'}
				FMT={
					sec.indent.block='true';
				}
				<BODY>
					<SS_CALL>
						COND='getBooleanParam("deriv.simpleContent.annotations")'
						FMT={
							sec.spacing.after='6';
							text.style='cs3';
						}
						SS_NAME='annotation'
					</SS_CALL>
					<SS_CALL>
						MATCHING_ET='xs:simpleType'
						BREAK_PARENT_BLOCK='when-executed'
						SS_NAME='simpleType'
					</SS_CALL>
					<SS_CALL>
						MATCHING_ET='xs:complexType'
						SS_NAME='complexType'
					</SS_CALL>
				</BODY>
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='s1';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<DATA_CTRL>
										FORMULA='\'"\' + getVar("typeQName") + \'"\''
									</DATA_CTRL>
									<LABEL>
										MATCHING_ET='xs:simpleType'
										TEXT='simpleType'
									</LABEL>
									<LABEL>
										MATCHING_ET='xs:complexType'
										TEXT='complexType'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
			</FOLDER>
			<FOLDER>
				DESCR='derivation of anonymous simpleType'
				COND='getAttrValue("base") == null'
				CONTEXT_ELEMENT_EXPR='findChild("xs:simpleType")'
				MATCHING_ET='xs:%localSimpleType'
				FMT={
					sec.indent.block='true';
				}
				<BODY>
					<SS_CALL>
						COND='getBooleanParam("deriv.simpleContent.annotations")'
						FMT={
							sec.spacing.after='6';
							text.style='cs3';
						}
						SS_NAME='annotation'
					</SS_CALL>
					<SS_CALL>
						SS_NAME='simpleType'
					</SS_CALL>
				</BODY>
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='s1';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										TEXT='Anonymous simpleType'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
			</FOLDER>
		</BODY>
	</FOLDER>
	<ELEMENT_ITER>
		MATCHING_ET='xs:%simpleType'
		FMT={
			txtfl.delimiter.type='space';
		}
		TARGET_ETS={'xs:list';'xs:restriction';'xs:union'}
		SCOPE='simple-location-rules'
		RULES={
			'* -> (xs:list|xs:restriction|xs:union)';
		}
		SS_NAME='simpleType'
		<BODY>
			<SS_CALL>
				DESCR='Derivation BY RESTRICTION'
				MATCHING_ET='xs:restriction'
				BREAK_PARENT_BLOCK='when-executed'
				SS_NAME='restriction'
			</SS_CALL>
			<FOLDER>
				DESCR='Derivation BY LIST'
				MATCHING_ET='xs:list'
				BREAK_PARENT_BLOCK='when-executed'
				COLLAPSED
				<BODY>
					<AREA_SEC>
						FMT={
							sec.outputStyle='table';
							table.cellpadding.both='0';
							table.border.style='none';
							trow.align.vert='Top';
						}
						<AREA>
							<CTRL_GROUP>
								FMT={
									trow.align.vert='Top';
								}
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='63';
											ctrl.size.height='17.3';
											par.style='s3';
										}
										TEXT='Derivation:'
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											ctrl.size.width='436.5';
											ctrl.size.height='17.3';
											par.style='s4';
										}
										SS_NAME='Derivation Method'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<FOLDER>
						DESCR='derivation of referenced list item type'
						COND='getAttrValue("itemType") != null &&\nhasParamValue("deriv.simpleContent", "full")'
						CONTEXT_ELEMENT_EXPR='typeQName = getAttrQNameValue("itemType");\n\nisXSPredefinedType (typeQName) ? null :\n{\n  setVar ("typeQName", typeQName);\n  findElementByKey ("types", typeQName);\n}'
						MATCHING_ET='xs:simpleType'
						FMT={
							sec.indent.block='true';
						}
						BREAK_PARENT_BLOCK='when-executed'
						<BODY>
							<SS_CALL>
								COND='getBooleanParam("deriv.simpleContent.annotations")'
								FMT={
									sec.spacing.after='6';
									text.style='cs3';
								}
								SS_NAME='annotation'
							</SS_CALL>
							<SS_CALL>
								SS_NAME='simpleType'
							</SS_CALL>
						</BODY>
						<HEADER>
							<AREA_SEC>
								FMT={
									par.style='s1';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<DATA_CTRL>
												FORMULA='\'"\' + getVar("typeQName") + \'"\''
											</DATA_CTRL>
											<LABEL>
												TEXT='simpleType'
											</LABEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</HEADER>
					</FOLDER>
					<FOLDER>
						DESCR='derivation of anonymous list item type'
						COND='getAttrValue("itemType") == null'
						CONTEXT_ELEMENT_EXPR='findChild("xs:simpleType")'
						MATCHING_ET='xs:%localSimpleType'
						FMT={
							sec.indent.block='true';
						}
						<BODY>
							<SS_CALL>
								COND='getBooleanParam("deriv.simpleContent.annotations")'
								FMT={
									sec.spacing.after='6';
									text.style='cs3';
								}
								SS_NAME='annotation'
							</SS_CALL>
							<SS_CALL>
								SS_NAME='simpleType'
							</SS_CALL>
						</BODY>
						<HEADER>
							<AREA_SEC>
								FMT={
									par.style='s1';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<LABEL>
												TEXT='Anonymous simpleType'
											</LABEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</HEADER>
					</FOLDER>
				</BODY>
			</FOLDER>
			<FOLDER>
				DESCR='Derivation BY UNION'
				MATCHING_ET='xs:union'
				<BODY>
					<AREA_SEC>
						FMT={
							sec.outputStyle='table';
							table.cellpadding.both='0';
							table.border.style='none';
							trow.align.vert='Top';
						}
						<AREA>
							<CTRL_GROUP>
								FMT={
									trow.align.vert='Top';
								}
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='63';
											ctrl.size.height='17.3';
											par.style='s3';
										}
										TEXT='Derivation:'
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											ctrl.size.width='436.5';
											ctrl.size.height='17.3';
											par.style='s4';
										}
										SS_NAME='Derivation Method'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<FOLDER>
						DESCR='derivation of member types'
						FMT={
							sec.outputStyle='list';
							text.style='cs10';
							list.type='ordered';
						}
						<BODY>
							<ATTR_ITER>
								DESCR='global member types'
								FMT={
									sec.outputStyle='list-items';
								}
								SCOPE='attr-values'
								ATTR='memberTypes'
								<BODY>
									<FOLDER>
										DESCR='derivation of a global member type'
										COND='hasParamValue("deriv.simpleContent", "full")'
										CONTEXT_ELEMENT_EXPR='typeQName = iterator.value.toQName();\n\nisXSPredefinedType (typeQName) ? null :\n  findElementByKey ("types", typeQName)'
										MATCHING_ET='xs:simpleType'
										<BODY>
											<SS_CALL>
												COND='getBooleanParam("deriv.simpleContent.annotations")'
												FMT={
													sec.spacing.after='6';
													text.style='cs3';
												}
												SS_NAME='annotation'
											</SS_CALL>
											<SS_CALL>
												SS_NAME='simpleType'
											</SS_CALL>
										</BODY>
										<HEADER>
											<AREA_SEC>
												FMT={
													par.margin.bottom='6';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<DATA_CTRL>
																FMT={
																	text.style='cs4';
																}
																<DOC_HLINK>
																	HKEYS={
																		'findElementByKey ("types", toQName (iterator.value)).id';
																		'Array ("detail", "xml-source-location")',array;
																	}
																</DOC_HLINK>
																FORMULA='iterator.value'
															</DATA_CTRL>
															<LABEL>
																TEXT='simpleType:'
															</LABEL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</AREA_SEC>
										</HEADER>
									</FOLDER>
									<AREA_SEC>
										COND='sectionBlock.execSecNone'
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<DATA_CTRL>
														FMT={
															text.style='cs4';
														}
														<DOC_HLINK>
															HKEYS={
																'findElementByKey ("types", toQName (iterator.value)).id';
																'Array ("detail", "xml-source-location")',array;
															}
														</DOC_HLINK>
														FORMULA='iterator.value'
													</DATA_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
								</BODY>
							</ATTR_ITER>
							<ELEMENT_ITER>
								DESCR='anonymous member types'
								FMT={
									sec.outputStyle='list-items';
									li.margin.top='6';
									li.margin.bottom='6';
								}
								TARGET_ET='xs:%localSimpleType'
								SCOPE='simple-location-rules'
								RULES={
									'* -> xs:%localSimpleType';
								}
								<BODY>
									<FOLDER>
										DESCR='derivation of an anonymous member type'
										<BODY>
											<AREA_SEC>
												FMT={
													par.margin.bottom='6';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<LABEL>
																TEXT='anonymous simpleType:'
															</LABEL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</AREA_SEC>
											<SS_CALL>
												COND='getBooleanParam("deriv.simpleContent.annotations")'
												FMT={
													sec.spacing.after='6';
													text.style='cs3';
												}
												SS_NAME='annotation'
											</SS_CALL>
											<SS_CALL>
												SS_NAME='simpleType'
											</SS_CALL>
										</BODY>
									</FOLDER>
								</BODY>
							</ELEMENT_ITER>
						</BODY>
						<HEADER>
							<AREA_SEC>
								FMT={
									text.font.style.italic='false';
									par.style='s1';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<LABEL>
												TEXT='Member Types'
											</LABEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</HEADER>
					</FOLDER>
				</BODY>
			</FOLDER>
		</BODY>
	</ELEMENT_ITER>
</STOCK_SECTIONS>
CHECKSUM='b+vBQ6J3V0E0MvCxtqOOvgTFeZKDqpN7wuj?C5e0keY'
</DOCFLEX_TEMPLATE>