<DOCFLEX_TEMPLATE VER='1.13'>
CREATED='2005-04-26 03:31:00'
LAST_UPDATE='2009-10-30 06:36:30'
DESIGNER_TOOL='DocFlex SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='docflex-xml-xsddoc2'
APP_NAME='DocFlex/XML XSDDoc'
APP_VER='2.2.0'
APP_AUTHOR='Copyright \u00a9 2005-2009 Filigris Works,\nLeonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='xsddoc'
ROOT_ETS={'xs:%element';'xs:attribute';'xs:attributeGroup';'xs:complexType';'xs:group';'xs:simpleType'}
DESCR='when the passed root element is an element component, it must be the element declaration (not a reference to it). The reference element component is also needed and must be passed via the \'referenceElement\' parameter.\n'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='showHeading';
		param.type='boolean';
		param.default.value='true';
	}
	PARAM={
		param.name='sorting';
		param.title='Specify whether to sort attributes';
		param.type='boolean';
	}
	PARAM={
		param.name='xmlName';
		param.description='The displayed XML name (qualified or local) of the element';
		param.type='string';
		param.hidden='true';
	}
	PARAM={
		param.name='referenceElement';
		param.description='The reference element component';
		param.type='Object';
	}
	PARAM={
		param.name='abbreviateAttrValue';
		param.description='Indicates that when an attribute value representation consists of the only enumeration, it should be abbreviated (shown as "enumeration of ...")';
		param.type='boolean';
	}
	PARAM={
		param.name='abbreviateSimpleContent';
		param.description='Indicates that when the element simple content representation consists of the only enumeration, it should be abbreviated (shown as "enumeration of ...")';
		param.type='boolean';
	}
	PARAM={
		param.name='fmt.allowNestedTables';
		param.title='Allow nested tables';
		param.type='boolean';
		param.default.value='true';
	}
</TEMPLATE_PARAMS>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs4';
}
<STYLES>
	CHAR_STYLE={
		style.name='Code Relative';
		style.id='cs1';
		text.font.name='Courier New';
		text.font.size.relative='90';
	}
	CHAR_STYLE={
		style.name='Code Smaller Relative';
		style.id='cs2';
		text.font.name='Courier New';
		text.font.size.relative='80';
	}
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs3';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs4';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='s1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Underline';
		style.id='cs5';
		text.decor.underline='true';
	}
	CHAR_STYLE={
		style.name='XML Markup';
		style.id='cs6';
		text.color.foreground='#0000FF';
		text.option.nbsps='true';
	}
	CHAR_STYLE={
		style.name='XML Name';
		style.id='cs7';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Attribute Name';
		style.id='cs8';
		text.font.name='Courier New';
		text.font.size.relative='80';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Content Model';
		style.id='cs9';
		text.font.name='Verdana';
		text.font.size.relative='85';
	}
	PAR_STYLE={
		style.name='XML Rep Heading';
		style.id='s2';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='2';
	}
	CHAR_STYLE={
		style.name='XML Source Relative';
		style.id='cs10';
		text.font.name='Verdana';
		text.font.size.relative='80';
	}
</STYLES>
<ROOT>
	<FOLDER>
		DESCR='case of element'
		COND='instanceOf("xs:%element")'
		CONTEXT_ELEMENT_EXPR='findElementByKey ("element-types", contextElement.id)'
		MATCHING_ETS={'#CUSTOM';'xs:%complexType';'xs:%simpleType'}
		BREAK_PARENT_BLOCK='when-executed'
		<BODY>
			<SS_CALL>
				MATCHING_ET='xs:%complexType'
				BREAK_PARENT_BLOCK='when-executed'
				SS_NAME='Element Rep (complexType)'
				PARAMS_EXPR='Array (getParam("xmlName"))'
			</SS_CALL>
			<SS_CALL>
				MATCHING_ETS={'#CUSTOM';'xs:%simpleType'}
				SS_NAME='Element Rep (simpleType)'
				PARAMS_EXPR='Array (getParam("xmlName"))'
			</SS_CALL>
		</BODY>
	</FOLDER>
	<SS_CALL>
		DESCR='case of complexType'
		MATCHING_ET='xs:%complexType'
		BREAK_PARENT_BLOCK='when-executed'
		SS_NAME='Element Rep (complexType)'
		PARAMS_EXPR='Array ("...")'
	</SS_CALL>
	<SS_CALL>
		DESCR='case of simpleType'
		MATCHING_ET='xs:simpleType'
		BREAK_PARENT_BLOCK='when-executed'
		SS_NAME='simpleType Rep'
	</SS_CALL>
	<SS_CALL>
		DESCR='case of element group'
		MATCHING_ET='xs:group'
		BREAK_PARENT_BLOCK='when-executed'
		SS_NAME='Element Group Rep'
	</SS_CALL>
	<SS_CALL>
		DESCR='case of attribute or attributeGroup'
		MATCHING_ETS={'xs:attribute';'xs:attributeGroup'}
		SS_NAME='Attribute Group Rep'
		PARAMS_EXPR='Array ("...")'
	</SS_CALL>
</ROOT>
<STOCK_SECTIONS>
	<FOLDER>
		MATCHING_ET='xs:anyAttribute'
		SS_NAME='Any Attribute'
		<BODY>
			<TEMPLATE_CALL>
				TEMPLATE_FILE='wildcard.tpl'
			</TEMPLATE_CALL>
		</BODY>
	</FOLDER>
	<FOLDER>
		MATCHING_ETS={'xs:attribute';'xs:attributeGroup'}
		FMT={
			sec.outputStyle='table';
			sec.page.keepTogether='true';
			table.sizing='Relative';
			table.cellpadding.both='0';
			table.bkgr.color='#F5F5F5';
			table.border.style='solid';
			table.border.color='#999999';
			table.border.horz.style='none';
			table.border.vert.style='none';
			table.option.borderStylesInHTML='true';
		}
		SS_NAME='Attribute Group Rep'
		<BODY>
			<ELEMENT_ITER>
				FMT={
					text.style='cs1';
				}
				TARGET_ET='xs:%attribute'
				SCOPE='custom'
				ELEMENT_ENUM_EXPR='rootElement.instanceOf ("xs:attribute") ? Enum (rootElement) : \n  findElementsByKey (\n    "content-model-attributes",\n    contextElement.id, \n    BooleanQuery (getAttrValue("use") != "prohibited")\n  )'
				SORTING='by-expr'
				SORTING_KEY={expr='hasAttr("name") ? callStockSection("Local Attribute Name") \n                : getAttrQNameValue("ref").toXMLName()',ascending,case_sensitive}
				SORTING_COND='getBooleanParam("sorting")'
				<BODY>
					<AREA_SEC>
						DESCR='local attribute'
						COND='getAttrStringValue("name") != ""'
						MATCHING_ET='xs:attribute%xs:attribute'
						BREAK_PARENT_BLOCK='when-executed'
						<AREA>
							<CTRL_GROUP>
								FMT={
									trow.align.vert='Top';
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='21';
											ctrl.size.height='17.3';
											tcell.padding.extra.left='4';
											text.option.nbsps='true';
										}
										TEXT='   '
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											content.outputStyle='text-par';
											ctrl.size.width='75';
											ctrl.size.height='17.3';
											tcell.option.nowrap='true';
											text.style='cs8';
											text.hlink.fmt='style';
											text.hlink.style='cs5';
										}
										<DOC_HLINK>
											TITLE_EXPR='"local attribute"'
											HKEYS={
												'contextElement.id';
												'"local"';
												'rootElement.id';
											}
										</DOC_HLINK>
										<DOC_HLINK>
											TITLE_EXPR='"local attribute"'
											HKEYS={
												'contextElement.id';
												'Array ("def", "xml-source-location")',array;
											}
										</DOC_HLINK>
										SS_NAME='Local Attribute Name'
									</SS_CALL_CTRL>
									<LABEL>
										FMT={
											ctrl.size.width='18.8';
											ctrl.size.height='17.3';
											tcell.align.horz='Center';
											text.style='cs6';
										}
										TEXT=' = '
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											ctrl.size.width='384.8';
											ctrl.size.height='17.3';
											tcell.sizing='Relative';
											tcell.padding.extra.right='4';
											text.style='cs2';
										}
										SS_NAME='Attribute Value'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						DESCR='attribute reference'
						COND='getAttrValue("ref") != null'
						MATCHING_ET='xs:attribute%xs:attribute'
						BREAK_PARENT_BLOCK='when-executed'
						<AREA>
							<CTRL_GROUP>
								FMT={
									trow.align.vert='Top';
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='20.3';
											ctrl.size.height='17.3';
											tcell.padding.extra.left='4';
											text.option.nbsps='true';
										}
										TEXT='   '
									</LABEL>
									<DATA_CTRL>
										FMT={
											ctrl.size.width='75';
											ctrl.size.height='17.3';
											tcell.option.nowrap='true';
											text.style='cs8';
											text.hlink.fmt='style';
											text.hlink.style='cs5';
										}
										<DOC_HLINK>
											TITLE_EXPR='"global attribute"'
											HKEYS={
												'contextElement.id';
												'"local"';
												'rootElement.id';
											}
										</DOC_HLINK>
										<DOC_HLINK>
											TITLE_EXPR='"global attribute"'
											HKEYS={
												'contextElement.id';
												'"def"';
											}
										</DOC_HLINK>
										<DOC_HLINK>
											TITLE_EXPR='"global attribute"'
											HKEYS={
												'getAttrQNameValue("ref")';
												'"attribute"';
											}
										</DOC_HLINK>
										<DOC_HLINK>
											TITLE_EXPR='"global attribute"'
											HKEYS={
												'contextElement.id';
												'"xml-source-location"';
											}
										</DOC_HLINK>
										FORMULA='getAttrQNameValue("ref").toXMLName()'
									</DATA_CTRL>
									<LABEL>
										FMT={
											ctrl.size.width='18.8';
											ctrl.size.height='17.3';
											tcell.align.horz='Center';
											text.style='cs6';
										}
										TEXT=' = '
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											ctrl.size.width='385.5';
											ctrl.size.height='17.3';
											tcell.sizing='Relative';
											tcell.padding.extra.right='4';
											text.style='cs2';
										}
										SS_NAME='Attribute Value'
										PASSED_ELEMENT_EXPR='findElementByKey (\n  "global-attributes",\n  getAttrQNameValue("ref")\n)'
										PASSED_ELEMENT_MATCHING_ET='xs:attribute'
										PARAMS_EXPR='Array (contextElement)'
										ALT_FORMULA='"???"'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						DESCR='global attribute'
						MATCHING_ET='xs:attribute'
						BREAK_PARENT_BLOCK='when-executed'
						<AREA>
							<CTRL_GROUP>
								FMT={
									trow.align.vert='Top';
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='21';
											ctrl.size.height='17.3';
											tcell.padding.extra.left='4';
											text.option.nbsps='true';
										}
										TEXT='   '
									</LABEL>
									<DATA_CTRL>
										FMT={
											ctrl.size.width='75';
											ctrl.size.height='17.3';
											tcell.option.nowrap='true';
											text.style='cs8';
											text.hlink.fmt='style';
											text.hlink.style='cs5';
										}
										<DOC_HLINK>
											HKEYS={
												'contextElement.id';
												'"detail"';
											}
										</DOC_HLINK>
										FORMULA='toXMLName (\n  findAncestor("xs:schema").getAttrStringValue("targetNamespace"),\n  getAttrStringValue("name")\n)'
									</DATA_CTRL>
									<LABEL>
										FMT={
											ctrl.size.width='18.8';
											ctrl.size.height='17.3';
											tcell.align.horz='Center';
											text.style='cs6';
										}
										TEXT=' = '
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											ctrl.size.width='384.8';
											ctrl.size.height='17.3';
											tcell.sizing='Relative';
											tcell.padding.extra.right='4';
											text.style='cs2';
										}
										SS_NAME='Attribute Value'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				FMT={
					text.style='cs1';
				}
				TARGET_ET='xs:anyAttribute'
				SCOPE='custom'
				ELEMENT_ENUM_EXPR='rootElement.instanceOf ("xs:attribute") ? Enum (rootElement) : \n  findElementsByKey ("content-model-attributes", contextElement.id)'
				<BODY>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='21';
											ctrl.size.height='17.3';
											tcell.padding.extra.left='4';
											text.option.nbsps='true';
										}
										TEXT='   '
									</LABEL>
									<SS_CALL_CTRL>
										FMT={
											content.outputStyle='text-par';
											ctrl.size.width='478.5';
											ctrl.size.height='17.3';
											tcell.sizing='Relative';
											tcell.padding.extra.right='4';
											text.style='cs8';
											text.font.style.italic='true';
											text.hlink.fmt='style';
											text.hlink.style='cs5';
										}
										<DOC_HLINK>
											HKEYS={
												'contextElement.id';
												'"local"';
												'rootElement.id';
											}
										</DOC_HLINK>
										<DOC_HLINK>
											HKEYS={
												'contextElement.id';
												'Array ("def", "xml-source-location")',array;
											}
										</DOC_HLINK>
										SS_NAME='Any Attribute'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
		</BODY>
		<HEADER>
			<AREA_SEC>
				COND='getBooleanParam("showHeading")'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<LABEL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='17.3';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.top='4';
									par.style='s2';
								}
								TEXT='XML Representation Summary'
							</LABEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				FMT={
					text.style='cs1';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<PANEL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='38.3';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.top='4';
									tcell.padding.extra.bottom='1';
								}
								<AREA>
									<CTRL_GROUP>
										FMT={
											txtfl.delimiter.type='none';
										}
										<CTRLS>
											<LABEL>
												FMT={
													text.style='cs6';
												}
												TEXT='<'
											</LABEL>
											<LABEL>
												FMT={
													text.style='cs7';
												}
												TEXT='...'
											</LABEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<FOOTER>
			<AREA_SEC>
				FMT={
					text.style='cs1';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<PANEL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='39.8';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.bottom='4';
								}
								<AREA>
									<CTRL_GROUP>
										FMT={
											txtfl.delimiter.type='none';
										}
										<CTRLS>
											<LABEL>
												FMT={
													text.style='cs7';
												}
												TEXT='...'
											</LABEL>
											<LABEL>
												FMT={
													text.style='cs6';
												}
												TEXT='>'
											</LABEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</FOOTER>
	</FOLDER>
	<FOLDER>
		DESCR='the passed context element must be the attribute declaration component (not a reference to it);\n\nparams[0]: in case of reference to a global attribute, the reference-attribute should be passed in the stock-section parameter'
		MATCHING_ET='xs:%attribute'
		FMT={
			sec.outputStyle='text-par';
		}
		SS_NAME='Attribute Value'
		<BODY>
			<AREA_SEC>
				COND='! getBooleanParam("abbreviateAttrValue")\n\n// see also "Context Element" tab'
				CONTEXT_ELEMENT_EXPR='hasAttr("fixed") ? contextElement :\n{\n  refAttr = stockSection.param.toElement();\n  refAttr.hasAttr("fixed") ? refAttr : null\n}'
				MATCHING_ET='xs:%attribute'
				BREAK_PARENT_BLOCK='when-executed'
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.delimiter.type='none';
						}
						<CTRLS>
							<LABEL>
								FMT={
									text.style='cs6';
								}
								TEXT='"'
							</LABEL>
							<DATA_CTRL>
								ATTR='fixed'
							</DATA_CTRL>
							<LABEL>
								FMT={
									text.style='cs6';
								}
								TEXT='"'
							</LABEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<FOLDER>
				DESCR='no fixed value'
				<BODY>
					<SS_CALL>
						DESCR='if there is \'type\' attribute'
						COND='hasAttr("type")'
						SS_NAME='Simple Content Model'
						PASSED_ELEMENT_EXPR='typeQName = getAttrQNameValue("type");\n\n((el = findElementByKey ("types", typeQName)) != null) ?\n  el : CustomElement (typeQName)'
						PASSED_ELEMENT_MATCHING_ETS={'#CUSTOM';'xs:%simpleType'}
						PARAMS_EXPR='Array (\n true,  // highlight XML markup\n true,  // always apply brackets\n getBooleanParam("abbreviateAttrValue")\n)'
					</SS_CALL>
					<ELEMENT_ITER>
						DESCR='else, the type is anonymous'
						COND='sectionBlock.execSecNone'
						TARGET_ET='xs:simpleType%xs:localSimpleType'
						SCOPE='simple-location-rules'
						RULES={
							'* -> xs:simpleType%xs:localSimpleType';
						}
						<BODY>
							<SS_CALL>
								SS_NAME='Simple Content Model'
								PARAMS_EXPR='Array (\n true,  // highlight XML markup\n true,  // always apply brackets\n getBooleanParam("abbreviateAttrValue")\n)'
							</SS_CALL>
						</BODY>
						<ELSE>
							DESCR='no type information specified at all'
							<AREA_SEC>
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<DATA_CTRL>
												FORMULA='toXMLName (getNamespaceURI("xs"), "anySimpleType")'
											</DATA_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</ELSE>
					</ELEMENT_ITER>
					<AREA_SEC>
						COND='// See "Context Element" tab'
						CONTEXT_ELEMENT_EXPR='refAttr = stockSection.param.toElement();\n\nrefAttr.hasAttr("default") ? refAttr :\n  hasAttr("default") ? contextElement : null'
						MATCHING_ET='xs:%attribute'
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<DELIMITER>
										FMT={
											txtfl.delimiter.type='text';
											txtfl.delimiter.text=' : ';
										}
									</DELIMITER>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='"'
									</LABEL>
									<DATA_CTRL>
										ATTR='default'
									</DATA_CTRL>
									<LABEL>
										FMT={
											text.style='cs6';
										}
										TEXT='"'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
		</BODY>
	</FOLDER>
	<FOLDER>
		MATCHING_ETS={'xs:%complexType';'xs:group'}
		SS_NAME='Complex Content Model'
		<BODY>
			<TEMPLATE_CALL>
				FMT={
					text.style='cs9';
				}
				TEMPLATE_FILE='complexContentModel.tpl'
				PASSED_PARAMS={
					'owner_id','rootElement.id';
				}
			</TEMPLATE_CALL>
		</BODY>
	</FOLDER>
	<FOLDER>
		MATCHING_ET='xs:group'
		FMT={
			sec.outputStyle='table';
			sec.page.keepTogether='true';
			table.sizing='Relative';
			table.cellpadding.both='0';
			table.bkgr.color='#F5F5F5';
			table.border.style='solid';
			table.border.color='#999999';
			table.border.horz.style='none';
			table.border.vert.style='none';
			table.option.borderStylesInHTML='true';
		}
		SS_NAME='Element Group Rep'
		<BODY>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<SS_CALL_CTRL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='17.3';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.top='4';
									tcell.padding.extra.bottom='4';
								}
								SS_NAME='Complex Content Model'
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
		<HEADER>
			<AREA_SEC>
				COND='getBooleanParam("showHeading")'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<LABEL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='17.3';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.top='4';
									par.style='s2';
								}
								TEXT='Complex Content Model'
							</LABEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
	</FOLDER>
	<FOLDER>
		DESCR='param: element\'s qualified name'
		MATCHING_ET='xs:%complexType'
		INIT_EXPR='contentType = \n  checkElementsByKey ("content-model-elements", contextElement.id) ? "complex"\n  :\n  (((el = findChild("xs:complexContent")) != null && el.hasAttr ("mixed"))\n    ? el.getAttrBooleanValue("mixed") : getAttrBooleanValue("mixed")) ? "complex"\n  :\n  hasChild("xs:simpleContent") && ! rootElement.hasAttrValue("fixed", "") ? "simple"\n  :\n  "empty";\n\nstockSection.setVar ("contentType", contentType);'
		FMT={
			sec.outputStyle='table';
			sec.page.keepTogether='true';
			table.sizing='Relative';
			table.cellpadding.both='0';
			table.bkgr.color='#F5F5F5';
			table.border.style='solid';
			table.border.color='#999999';
			table.border.horz.style='none';
			table.border.vert.style='none';
			table.option.borderStylesInHTML='true';
		}
		SS_NAME='Element Rep (complexType)'
		<BODY>
			<FOLDER>
				DESCR='NON-EMPTY CONTENT'
				COND='stockSection.getVar("contentType") != "empty"'
				OUTPUT_CHECKER_EXPR='// the output does exist as that was already tested \n// in the Enabling Condition;\n// (1 means "yes"; -1 means "no"; 0 means "unknown")\n\n1'
				FMT={
					text.style='cs1';
				}
				BREAK_PARENT_BLOCK='when-executed'
				<BODY>
					<FOLDER>
						DESCR='START TAG'
						<BODY>
							<ELEMENT_ITER>
								TARGET_ET='xs:%attribute'
								SCOPE='custom'
								ELEMENT_ENUM_EXPR='findElementsByKey (\n  "content-model-attributes",\n  contextElement.id,\n  BooleanQuery (getAttrValue("use") != "prohibited")\n)'
								SORTING='by-expr'
								SORTING_KEY={expr='hasAttr("name") ? callStockSection("Local Attribute Name") \n                : getAttrQNameValue("ref").toXMLName()',ascending,case_sensitive}
								SORTING_COND='getBooleanParam("sorting")'
								<BODY>
									<AREA_SEC>
										COND='getAttrStringValue("name") != ""'
										BREAK_PARENT_BLOCK='when-executed'
										<AREA>
											<CTRL_GROUP>
												FMT={
													trow.align.vert='Top';
													txtfl.delimiter.type='none';
												}
												<CTRLS>
													<LABEL>
														FMT={
															ctrl.size.width='21.8';
															ctrl.size.height='17.3';
															tcell.padding.extra.left='4';
															text.option.nbsps='true';
														}
														TEXT='   '
													</LABEL>
													<SS_CALL_CTRL>
														FMT={
															content.outputStyle='text-par';
															ctrl.size.width='75';
															ctrl.size.height='17.3';
															tcell.option.nowrap='true';
															text.style='cs8';
															text.hlink.fmt='style';
															text.hlink.style='cs5';
														}
														<DOC_HLINK>
															TITLE_EXPR='"local attribute"'
															HKEYS={
																'contextElement.id';
																'"local"';
																'rootElement.id';
															}
														</DOC_HLINK>
														<DOC_HLINK>
															TITLE_EXPR='"local attribute"'
															HKEYS={
																'contextElement.id';
																'Array ("def", "xml-source-location")',array;
															}
														</DOC_HLINK>
														SS_NAME='Local Attribute Name'
													</SS_CALL_CTRL>
													<LABEL>
														FMT={
															ctrl.size.width='18.8';
															ctrl.size.height='17.3';
															tcell.align.horz='Center';
															text.style='cs6';
														}
														TEXT=' = '
													</LABEL>
													<SS_CALL_CTRL>
														FMT={
															ctrl.size.width='384';
															ctrl.size.height='17.3';
															tcell.sizing='Relative';
															tcell.padding.extra.right='4';
															text.style='cs2';
														}
														SS_NAME='Attribute Value'
													</SS_CALL_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
									<AREA_SEC>
										COND='getAttrValue("ref") != null'
										<AREA>
											<CTRL_GROUP>
												FMT={
													trow.align.vert='Top';
													txtfl.delimiter.type='none';
												}
												<CTRLS>
													<LABEL>
														FMT={
															ctrl.size.width='21';
															ctrl.size.height='17.3';
															tcell.padding.extra.left='4';
															text.option.nbsps='true';
														}
														TEXT='   '
													</LABEL>
													<DATA_CTRL>
														FMT={
															ctrl.size.width='75';
															ctrl.size.height='17.3';
															tcell.option.nowrap='true';
															text.style='cs8';
															text.hlink.fmt='style';
															text.hlink.style='cs5';
														}
														<DOC_HLINK>
															TITLE_EXPR='"global attribute"'
															HKEYS={
																'contextElement.id';
																'"local"';
																'rootElement.id';
															}
														</DOC_HLINK>
														<DOC_HLINK>
															TITLE_EXPR='"global attribute"'
															HKEYS={
																'contextElement.id';
																'"def"';
															}
														</DOC_HLINK>
														<DOC_HLINK>
															TITLE_EXPR='"global attribute"'
															HKEYS={
																'getAttrQNameValue("ref")';
																'"attribute"';
															}
														</DOC_HLINK>
														<DOC_HLINK>
															TITLE_EXPR='"global attribute"'
															HKEYS={
																'contextElement.id';
																'"xml-source-location"';
															}
														</DOC_HLINK>
														FORMULA='getAttrQNameValue("ref").toXMLName()'
													</DATA_CTRL>
													<LABEL>
														FMT={
															ctrl.size.width='18.8';
															ctrl.size.height='17.3';
															tcell.align.horz='Center';
															text.style='cs6';
														}
														TEXT=' = '
													</LABEL>
													<SS_CALL_CTRL>
														FMT={
															ctrl.size.width='384.8';
															ctrl.size.height='17.3';
															tcell.sizing='Relative';
															tcell.padding.extra.right='4';
															text.style='cs2';
														}
														SS_NAME='Attribute Value'
														PASSED_ELEMENT_EXPR='findElementByKey (\n  "global-attributes",\n  getAttrQNameValue("ref")\n)'
														PASSED_ELEMENT_MATCHING_ET='xs:attribute'
														PARAMS_EXPR='Array (contextElement)'
														ALT_FORMULA='"???"'
													</SS_CALL_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
								</BODY>
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								FMT={
									text.style='cs1';
								}
								TARGET_ET='xs:anyAttribute'
								SCOPE='custom'
								ELEMENT_ENUM_EXPR='findElementsByKey ("content-model-attributes", contextElement.id)'
								<BODY>
									<AREA_SEC>
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<LABEL>
														FMT={
															ctrl.size.width='21';
															ctrl.size.height='17.3';
															tcell.padding.extra.left='4';
															text.option.nbsps='true';
														}
														TEXT='   '
													</LABEL>
													<SS_CALL_CTRL>
														FMT={
															content.outputStyle='text-par';
															ctrl.size.width='478.5';
															ctrl.size.height='17.3';
															tcell.sizing='Relative';
															tcell.padding.extra.right='4';
															text.style='cs8';
															text.font.style.italic='true';
															text.hlink.fmt='style';
															text.hlink.style='cs5';
														}
														<DOC_HLINK>
															HKEYS={
																'contextElement.id';
																'"local"';
																'rootElement.id';
															}
														</DOC_HLINK>
														<DOC_HLINK>
															HKEYS={
																'contextElement.id';
																'Array ("def", "xml-source-location")',array;
															}
														</DOC_HLINK>
														SS_NAME='Any Attribute'
													</SS_CALL_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
								</BODY>
							</ELEMENT_ITER>
						</BODY>
						<HEADER>
							<AREA_SEC>
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<PANEL>
												FMT={
													ctrl.size.width='499.5';
													ctrl.size.height='38.3';
													tcell.padding.extra.left='4';
													tcell.padding.extra.right='4';
													tcell.padding.extra.top='4';
												}
												<AREA>
													<CTRL_GROUP>
														FMT={
															txtfl.delimiter.type='none';
														}
														<CTRLS>
															<LABEL>
																FMT={
																	text.style='cs6';
																}
																TEXT='<'
															</LABEL>
															<DATA_CTRL>
																FMT={
																	text.style='cs7';
																}
																FORMULA='stockSection.param'
															</DATA_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</HEADER>
						<FOOTER>
							<AREA_SEC>
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='19.5';
													ctrl.size.height='17.3';
													tcell.padding.extra.left='4';
													text.option.nbsps='true';
												}
												TEXT='   '
											</LABEL>
											<LABEL>
												FMT={
													ctrl.size.width='480';
													ctrl.size.height='17.3';
													tcell.sizing='Relative';
													tcell.padding.extra.right='4';
													text.style='cs6';
												}
												TEXT='>'
											</LABEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</FOOTER>
						<ELSE>
							<AREA_SEC>
								<AREA>
									<CTRL_GROUP>
										FMT={
											txtfl.delimiter.type='none';
										}
										<CTRLS>
											<PANEL>
												FMT={
													ctrl.size.width='499.5';
													ctrl.size.height='38.3';
													tcell.padding.extra.left='4';
													tcell.padding.extra.right='4';
													tcell.padding.extra.top='4';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<LABEL>
																FMT={
																	text.style='cs6';
																}
																TEXT='<'
															</LABEL>
															<DATA_CTRL>
																FMT={
																	text.style='cs7';
																}
																FORMULA='stockSection.param'
															</DATA_CTRL>
															<LABEL>
																FMT={
																	text.style='cs6';
																}
																TEXT='>'
															</LABEL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</ELSE>
					</FOLDER>
					<FOLDER>
						DESCR='COMPLEX CONTENT'
						COND='stockSection.getVar("contentType") == "complex"'
						BREAK_PARENT_BLOCK='when-executed'
						COLLAPSED
						<BODY>
							<AREA_SEC>
								COND='getBooleanParam("fmt.allowNestedTables")'
								FMT={
									table.border.style='none';
								}
								BREAK_PARENT_BLOCK='when-executed'
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='21';
													ctrl.size.height='59.3';
													tcell.padding.extra.left='4';
													text.option.nbsps='true';
												}
												TEXT='   '
											</LABEL>
											<PANEL>
												FMT={
													content.outputStyle='table';
													ctrl.size.width='478.5';
													ctrl.size.height='59.3';
													tcell.sizing='Relative';
													table.cellpadding.both='0';
													table.border.style='none';
												}
												<AREA>
													<CTRL_GROUP>
														FMT={
															trow.align.vert='Top';
														}
														<CTRLS>
															<PANEL>
																FMT={
																	ctrl.size.width='75';
																	ctrl.size.height='38.3';
																	txtfl.delimiter.type='none';
																	par.option.nowrap='true';
																}
																<AREA>
																	<CTRL_GROUP>
																		<CTRLS>
																			<LABEL>
																				FMT={
																					text.font.style.italic='true';
																				}
																				TEXT='Content:'
																			</LABEL>
																			<LABEL>
																				FMT={
																					text.option.nbsps='true';
																				}
																				TEXT=' '
																			</LABEL>
																		</CTRLS>
																	</CTRL_GROUP>
																</AREA>
															</PANEL>
															<SS_CALL_CTRL>
																FMT={
																	ctrl.size.width='381';
																	ctrl.size.height='38.3';
																	tcell.padding.extra.right='4';
																}
																SS_NAME='Complex Content Model'
															</SS_CALL_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
							<AREA_SEC>
								FMT={
									table.border.style='none';
								}
								<AREA>
									<CTRL_GROUP>
										FMT={
											trow.align.vert='Top';
										}
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='21';
													ctrl.size.height='38.3';
													tcell.padding.extra.left='4';
													text.option.nbsps='true';
												}
												TEXT='   '
											</LABEL>
											<PANEL>
												FMT={
													ctrl.size.width='75';
													ctrl.size.height='38.3';
													txtfl.delimiter.type='none';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<LABEL>
																FMT={
																	text.font.style.italic='true';
																}
																TEXT='Content:'
															</LABEL>
															<LABEL>
																FMT={
																	text.option.nbsps='true';
																}
																TEXT=' '
															</LABEL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
											<SS_CALL_CTRL>
												FMT={
													ctrl.size.width='403.5';
													ctrl.size.height='38.3';
													tcell.sizing='Relative';
													tcell.padding.extra.right='4';
												}
												SS_NAME='Complex Content Model'
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</BODY>
					</FOLDER>
					<FOLDER>
						DESCR='SIMPLE CONTENT'
						COND='stockSection.getVar("contentType") == "simple"'
						COLLAPSED
						<BODY>
							<AREA_SEC>
								COND='getBooleanParam("fmt.allowNestedTables")'
								FMT={
									table.border.style='none';
								}
								BREAK_PARENT_BLOCK='when-executed'
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='21';
													ctrl.size.height='59.3';
													tcell.padding.extra.left='4';
													text.option.nbsps='true';
												}
												TEXT='   '
											</LABEL>
											<PANEL>
												FMT={
													content.outputStyle='table';
													ctrl.size.width='478.5';
													ctrl.size.height='59.3';
													tcell.sizing='Relative';
													table.cellpadding.both='0';
													table.border.style='none';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<PANEL>
																FMT={
																	ctrl.size.width='75';
																	ctrl.size.height='38.3';
																	tcell.align.vert='Top';
																	txtfl.delimiter.type='none';
																	par.option.nowrap='true';
																}
																<AREA>
																	<CTRL_GROUP>
																		<CTRLS>
																			<LABEL>
																				FMT={
																					text.font.style.italic='true';
																				}
																				TEXT='Content:'
																			</LABEL>
																			<LABEL>
																				FMT={
																					text.font.size='8';
																					text.option.nbsps='true';
																				}
																				TEXT=' '
																			</LABEL>
																		</CTRLS>
																	</CTRL_GROUP>
																</AREA>
															</PANEL>
															<SS_CALL_CTRL>
																FMT={
																	ctrl.size.width='381';
																	ctrl.size.height='38.3';
																	tcell.align.vert='Center';
																	tcell.padding.extra.right='4';
																	text.style='cs2';
																}
																SS_NAME='Element Simple Content'
															</SS_CALL_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
							<AREA_SEC>
								FMT={
									table.border.style='none';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='21';
													ctrl.size.height='38.3';
													tcell.padding.extra.left='4';
													text.option.nbsps='true';
												}
												TEXT='   '
											</LABEL>
											<PANEL>
												FMT={
													ctrl.size.width='75';
													ctrl.size.height='38.3';
													tcell.align.vert='Top';
													txtfl.delimiter.type='none';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<LABEL>
																FMT={
																	text.font.style.italic='true';
																}
																TEXT='Content:'
															</LABEL>
															<LABEL>
																FMT={
																	text.font.size='8';
																	text.option.nbsps='true';
																}
																TEXT=' '
															</LABEL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
											<SS_CALL_CTRL>
												FMT={
													ctrl.size.width='403.5';
													ctrl.size.height='38.3';
													tcell.sizing='Relative';
													tcell.align.vert='Center';
													tcell.padding.extra.right='4';
													text.style='cs2';
												}
												SS_NAME='Element Simple Content'
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</BODY>
					</FOLDER>
				</BODY>
				<FOOTER>
					DESCR='END TAG'
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='499.5';
											ctrl.size.height='38.3';
											tcell.padding.extra.left='4';
											tcell.padding.extra.right='4';
											tcell.padding.extra.bottom='4';
										}
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='</'
													</LABEL>
													<DATA_CTRL>
														FMT={
															text.style='cs7';
														}
														FORMULA='stockSection.param'
													</DATA_CTRL>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='>'
													</LABEL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</FOOTER>
			</FOLDER>
			<FOLDER>
				DESCR='EMPTY CONTENT'
				FMT={
					text.style='cs1';
				}
				COLLAPSED
				<BODY>
					<ELEMENT_ITER>
						TARGET_ET='xs:%attribute'
						SCOPE='custom'
						ELEMENT_ENUM_EXPR='findElementsByKey (\n  "content-model-attributes",\n  contextElement.id,\n  BooleanQuery (getAttrValue("use") != "prohibited")\n)'
						SORTING='by-expr'
						SORTING_KEY={expr='hasAttr("name") ? callStockSection("Local Attribute Name")\n                : getAttrQNameValue("ref").toXMLName()',ascending,case_sensitive}
						SORTING_COND='getBooleanParam("sorting")'
						<BODY>
							<AREA_SEC>
								COND='getAttrStringValue("name") != ""'
								BREAK_PARENT_BLOCK='when-executed'
								<AREA>
									<CTRL_GROUP>
										FMT={
											trow.align.vert='Top';
											txtfl.delimiter.type='none';
										}
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='21';
													ctrl.size.height='17.3';
													tcell.padding.extra.left='4';
													text.option.nbsps='true';
												}
												TEXT='   '
											</LABEL>
											<SS_CALL_CTRL>
												FMT={
													content.outputStyle='text-par';
													ctrl.size.width='75';
													ctrl.size.height='17.3';
													tcell.option.nowrap='true';
													text.style='cs8';
													text.hlink.fmt='style';
													text.hlink.style='cs5';
												}
												<DOC_HLINK>
													TITLE_EXPR='"local attribute"'
													HKEYS={
														'contextElement.id';
														'"local"';
														'rootElement.id';
													}
												</DOC_HLINK>
												<DOC_HLINK>
													TITLE_EXPR='"local attribute"'
													HKEYS={
														'contextElement.id';
														'Array ("detail", "xml-source-location")',array;
													}
												</DOC_HLINK>
												SS_NAME='Local Attribute Name'
											</SS_CALL_CTRL>
											<LABEL>
												FMT={
													ctrl.size.width='18.8';
													ctrl.size.height='17.3';
													tcell.align.horz='Center';
													text.style='cs6';
												}
												TEXT=' = '
											</LABEL>
											<SS_CALL_CTRL>
												FMT={
													ctrl.size.width='384.8';
													ctrl.size.height='17.3';
													tcell.sizing='Relative';
													tcell.padding.extra.right='4';
													text.style='cs2';
												}
												SS_NAME='Attribute Value'
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
							<AREA_SEC>
								COND='getAttrValue("ref") != null'
								<AREA>
									<CTRL_GROUP>
										FMT={
											trow.align.vert='Top';
											txtfl.delimiter.type='none';
										}
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='20.3';
													ctrl.size.height='17.3';
													tcell.padding.extra.left='4';
													text.option.nbsps='true';
												}
												TEXT='   '
											</LABEL>
											<DATA_CTRL>
												FMT={
													ctrl.size.width='75';
													ctrl.size.height='17.3';
													tcell.option.nowrap='true';
													text.style='cs8';
													text.hlink.fmt='style';
													text.hlink.style='cs5';
												}
												<DOC_HLINK>
													TITLE_EXPR='"global attribute"'
													HKEYS={
														'contextElement.id';
														'"local"';
														'rootElement.id';
													}
												</DOC_HLINK>
												<DOC_HLINK>
													TITLE_EXPR='"global attribute"'
													HKEYS={
														'contextElement.id';
														'"def"';
													}
												</DOC_HLINK>
												<DOC_HLINK>
													TITLE_EXPR='"global attribute"'
													HKEYS={
														'getAttrQNameValue("ref")';
														'"attribute"';
													}
												</DOC_HLINK>
												<DOC_HLINK>
													TITLE_EXPR='"global attribute"'
													HKEYS={
														'contextElement.id';
														'"xml-source-location"';
													}
												</DOC_HLINK>
												FORMULA='getAttrQNameValue("ref").toXMLName()'
											</DATA_CTRL>
											<LABEL>
												FMT={
													ctrl.size.width='18.8';
													ctrl.size.height='17.3';
													tcell.align.horz='Center';
													text.style='cs6';
												}
												TEXT=' = '
											</LABEL>
											<SS_CALL_CTRL>
												FMT={
													ctrl.size.width='385.5';
													ctrl.size.height='17.3';
													tcell.sizing='Relative';
													tcell.padding.extra.right='4';
													text.style='cs2';
												}
												SS_NAME='Attribute Value'
												PASSED_ELEMENT_EXPR='findElementByKey (\n  "global-attributes",\n  getAttrQNameValue("ref")\n)'
												PASSED_ELEMENT_MATCHING_ET='xs:attribute'
												PARAMS_EXPR='Array (contextElement)'
												ALT_FORMULA='"???"'
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</BODY>
					</ELEMENT_ITER>
					<ELEMENT_ITER>
						FMT={
							text.style='cs1';
						}
						TARGET_ET='xs:anyAttribute'
						SCOPE='custom'
						ELEMENT_ENUM_EXPR='findElementsByKey ("content-model-attributes", contextElement.id)'
						<BODY>
							<AREA_SEC>
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<LABEL>
												FMT={
													ctrl.size.width='21';
													ctrl.size.height='17.3';
													tcell.padding.extra.left='4';
													tcell.option.nowrap='true';
													text.option.nbsps='true';
												}
												TEXT='   '
											</LABEL>
											<SS_CALL_CTRL>
												FMT={
													content.outputStyle='text-par';
													ctrl.size.width='478.5';
													ctrl.size.height='17.3';
													tcell.sizing='Relative';
													tcell.padding.extra.right='4';
													text.style='cs8';
													text.font.style.italic='true';
													text.hlink.fmt='style';
													text.hlink.style='cs5';
												}
												<DOC_HLINK>
													HKEYS={
														'contextElement.id';
														'"local"';
														'rootElement.id';
													}
												</DOC_HLINK>
												<DOC_HLINK>
													HKEYS={
														'contextElement.id';
														'Array ("detail", "xml-source-location")',array;
													}
												</DOC_HLINK>
												SS_NAME='Any Attribute'
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</BODY>
					</ELEMENT_ITER>
				</BODY>
				<HEADER>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='499.5';
											ctrl.size.height='38.3';
											tcell.padding.extra.left='4';
											tcell.padding.extra.right='4';
											tcell.padding.extra.top='4';
										}
										<AREA>
											<CTRL_GROUP>
												FMT={
													txtfl.delimiter.type='none';
												}
												<CTRLS>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='<'
													</LABEL>
													<DATA_CTRL>
														FMT={
															text.style='cs7';
														}
														FORMULA='stockSection.param'
													</DATA_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<FOOTER>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='499.5';
											ctrl.size.height='17.3';
											tcell.padding.extra.left='4';
											tcell.padding.extra.right='4';
											tcell.padding.extra.bottom='4';
											text.style='cs6';
										}
										TEXT='/>'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</FOOTER>
				<ELSE>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='499.5';
											ctrl.size.height='39.8';
											tcell.padding.extra.left='4';
											tcell.padding.extra.right='4';
											tcell.padding.extra.top='4';
											tcell.padding.extra.bottom='4';
										}
										<AREA>
											<CTRL_GROUP>
												FMT={
													txtfl.delimiter.type='none';
												}
												<CTRLS>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='<'
													</LABEL>
													<DATA_CTRL>
														FMT={
															text.style='cs7';
														}
														FORMULA='stockSection.param'
													</DATA_CTRL>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='/>'
													</LABEL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</ELSE>
			</FOLDER>
		</BODY>
		<HEADER>
			<AREA_SEC>
				COND='getBooleanParam("showHeading")'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<LABEL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='17.3';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.top='4';
									par.style='s2';
								}
								TEXT='XML Representation Summary'
							</LABEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
	</FOLDER>
	<FOLDER>
		DESCR='param: element\'s qualified name'
		MATCHING_ETS={'#CUSTOM';'xs:%simpleType'}
		INIT_EXPR='contentType = ! rootElement.hasAttrValue("fixed", "") ? "simple" : "empty";\nstockSection.setVar ("contentType", contentType);'
		FMT={
			sec.outputStyle='table';
			sec.page.keepTogether='true';
			table.sizing='Relative';
			table.cellpadding.both='0';
			table.bkgr.color='#F5F5F5';
			table.border.style='solid';
			table.border.color='#999999';
			table.border.horz.style='none';
			table.border.vert.style='none';
			table.option.borderStylesInHTML='true';
		}
		SS_NAME='Element Rep (simpleType)'
		<BODY>
			<FOLDER>
				DESCR='NON-EMPTY CONTENT'
				COND='stockSection.getVar("contentType") != "empty"'
				OUTPUT_CHECKER_EXPR='// the output does exist as that was already tested \n// in the Enabling Condition;\n// (1 means "yes"; -1 means "no"; 0 means "unknown")\n\n1'
				FMT={
					text.style='cs1';
				}
				BREAK_PARENT_BLOCK='when-executed'
				<BODY>
					<AREA_SEC>
						COND='instanceOf ("#CUSTOM") &&\ncontextElement.value.toQName().isXSPredefinedType ("anyType")'
						BREAK_PARENT_BLOCK='when-executed'
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='23.3';
											ctrl.size.height='17.3';
											tcell.padding.extra.left='4';
											text.option.nbsps='true';
										}
										TEXT='   '
									</LABEL>
									<LABEL>
										FMT={
											ctrl.size.width='476.3';
											ctrl.size.height='17.3';
											tcell.sizing='Relative';
											tcell.align.vert='Center';
											tcell.padding.extra.right='4';
											text.style='cs2';
										}
										TEXT='...'
									</LABEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<LABEL>
										FMT={
											ctrl.size.width='23.3';
											ctrl.size.height='38.3';
											tcell.padding.extra.left='4';
											text.option.nbsps='true';
										}
										TEXT='   '
									</LABEL>
									<PANEL>
										FMT={
											ctrl.size.width='75';
											ctrl.size.height='38.3';
											tcell.align.vert='Top';
											txtfl.delimiter.type='none';
											par.option.nowrap='true';
										}
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<LABEL>
														FMT={
															text.font.style.italic='true';
														}
														TEXT='Content:'
													</LABEL>
													<LABEL>
														FMT={
															text.style='cs1';
															text.font.size='8';
															text.option.nbsps='true';
														}
														TEXT=' '
													</LABEL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
									<SS_CALL_CTRL>
										FMT={
											ctrl.size.width='401.3';
											ctrl.size.height='38.3';
											tcell.sizing='Relative';
											tcell.align.vert='Center';
											tcell.padding.extra.right='4';
											text.style='cs2';
										}
										SS_NAME='Element Simple Content'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
				<HEADER>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='499.5';
											ctrl.size.height='38.3';
											tcell.padding.extra.left='4';
											tcell.padding.extra.right='4';
											tcell.padding.extra.top='4';
										}
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='<'
													</LABEL>
													<DATA_CTRL>
														FMT={
															text.style='cs7';
														}
														FORMULA='stockSection.param'
													</DATA_CTRL>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='>'
													</LABEL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<FOOTER>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='499.5';
											ctrl.size.height='38.3';
											tcell.padding.extra.left='4';
											tcell.padding.extra.right='4';
											tcell.padding.extra.bottom='4';
										}
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='</'
													</LABEL>
													<DATA_CTRL>
														FMT={
															text.style='cs7';
														}
														FORMULA='stockSection.param'
													</DATA_CTRL>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='>'
													</LABEL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</FOOTER>
			</FOLDER>
			<FOLDER>
				DESCR='EMPTY CONTENT'
				FMT={
					text.style='cs1';
				}
				<BODY>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.delimiter.type='none';
								}
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='499.5';
											ctrl.size.height='39.8';
											tcell.padding.extra.left='4';
											tcell.padding.extra.right='4';
											tcell.padding.extra.top='4';
											tcell.padding.extra.bottom='4';
										}
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='<'
													</LABEL>
													<DATA_CTRL>
														FMT={
															text.style='cs7';
														}
														FORMULA='stockSection.param'
													</DATA_CTRL>
													<LABEL>
														FMT={
															text.style='cs6';
														}
														TEXT='/>'
													</LABEL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
		</BODY>
		<HEADER>
			<AREA_SEC>
				COND='getBooleanParam("showHeading")'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<LABEL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='17.3';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.top='4';
									par.style='s2';
								}
								TEXT='XML Representation Summary'
							</LABEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
	</FOLDER>
	<FOLDER>
		MATCHING_ETS={'#CUSTOM';'xs:%complexType';'xs:%simpleType'}
		FMT={
			sec.outputStyle='text-par';
		}
		SS_NAME='Element Simple Content'
		<BODY>
			<FOLDER>
				DESCR='in case the template\'s root element is \'%element\', some settings specified in it need to be printed; (switch to it the current context element; see "Context Element" tab)'
				COND='! getBooleanParam("abbreviateSimpleContent")'
				CONTEXT_ELEMENT_EXPR='rootElement'
				MATCHING_ET='xs:%element'
				BREAK_PARENT_BLOCK='when-executed'
				<BODY>
					<FOLDER>
						DESCR='if \'fixed\' attr is specified and its value is not empty (the empty value actually defines the EMPTY content model!)'
						COND='// see "Context Element" tab'
						CONTEXT_ELEMENT_EXPR='hasAttr("fixed") ? contextElement :\n{\n  el = getParam("referenceElement").toElement();\n  el.hasAttr("fixed") ? el : null\n}'
						MATCHING_ET='xs:%element'
						<BODY>
							<AREA_SEC>
								<AREA>
									<CTRL_GROUP>
										FMT={
											txtfl.delimiter.type='none';
										}
										<CTRLS>
											<LABEL>
												TEXT='"'
											</LABEL>
											<DATA_CTRL>
												ATTR='fixed'
											</DATA_CTRL>
											<LABEL>
												TEXT='"'
											</LABEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</BODY>
					</FOLDER>
					<FOLDER>
						DESCR='when there\'s no \'fixed\' attribute'
						COND='! hasAttr("fixed")'
						<BODY>
							<AREA_SEC>
								DESCR='if there\'s \'default\' attribute'
								COND='// see "Context Element" tab'
								CONTEXT_ELEMENT_EXPR='referenceElement = getParam("referenceElement").toElement();\n\nreferenceElement.hasAttr("default") ? referenceElement :\n  hasAttr("fixed") ? contextElement : null'
								MATCHING_ET='xs:%element'
								BREAK_PARENT_BLOCK='when-executed'
								<AREA>
									<CTRL_GROUP>
										FMT={
											txtfl.delimiter.type='none';
										}
										<CTRLS>
											<SS_CALL_CTRL>
												SS_NAME='Simple Content Model'
												PASSED_ELEMENT_EXPR='stockSection.contextElement'
												PASSED_ELEMENT_MATCHING_ETS={'#CUSTOM';'xs:%complexType';'xs:%simpleType'}
												PARAMS_EXPR='Array (true)'
											</SS_CALL_CTRL>
											<DELIMITER>
												FMT={
													txtfl.delimiter.type='text';
													txtfl.delimiter.text=' : ';
												}
											</DELIMITER>
											<LABEL>
												TEXT='"'
											</LABEL>
											<DATA_CTRL>
												ATTR='default'
											</DATA_CTRL>
											<LABEL>
												TEXT='"'
											</LABEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
							<SS_CALL>
								DESCR='otherwise, no \'default\' attribute; print the simple content model (back to the element received by this stock-section)'
								SS_NAME='Simple Content Model'
								PASSED_ELEMENT_EXPR='stockSection.contextElement'
								PASSED_ELEMENT_MATCHING_ETS={'#CUSTOM';'xs:%complexType';'xs:%simpleType'}
							</SS_CALL>
						</BODY>
					</FOLDER>
				</BODY>
			</FOLDER>
			<SS_CALL>
				DESCR='otherwise, just print the simple content model'
				SS_NAME='Simple Content Model'
				PARAMS_EXPR='Array (\n false, \n false, \n getBooleanParam("abbreviateSimpleContent")\n)'
			</SS_CALL>
		</BODY>
		<HEADER>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<LABEL>
								FMT={
									text.style='cs10';
								}
								TEXT='{ '
							</LABEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<FOOTER>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<LABEL>
								FMT={
									text.style='cs10';
								}
								TEXT=' }'
							</LABEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</FOOTER>
	</FOLDER>
	<AREA_SEC>
		MATCHING_ET='xs:%attribute'
		FMT={
			par.option.nowrap='true';
		}
		SS_NAME='Local Attribute Name'
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<DATA_CTRL>
						FORMULA='name = getAttrStringValue("name");\nschema = findAncestor ("xs:schema");\n\n(hasAttr("form") ? getAttrValue("form") : \n schema.getAttrValue ("attributeFormDefault")) == "qualified"\n? \n toXMLName (schema.getAttrStringValue("targetNamespace"), name) : name'
					</DATA_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<FOLDER>
		DESCR='params[0]: highlight XML markup;\nparams[1]: apply all brackets\nparams[2]: abbreviate simple content representation'
		MATCHING_ETS={'#CUSTOM';'xs:%complexType';'xs:%simpleType'}
		FMT={
			sec.outputStyle='text-par';
		}
		SS_NAME='Simple Content Model'
		<BODY>
			<TEMPLATE_CALL>
				MATCHING_ETS={'xs:%complexType';'xs:%simpleType'}
				TEMPLATE_FILE='simpleContentRep.tpl'
				PASSED_PARAMS={
					'highlight_markup','stockSection.params[0].toBoolean()';
					'apply_brackets','stockSection.params[1].toBoolean()';
					'abbreviate_enum','stockSection.params[2].toBoolean()';
				}
				BREAK_PARENT_BLOCK='when-executed'
			</TEMPLATE_CALL>
			<AREA_SEC>
				MATCHING_ET='#CUSTOM'
				COLLAPSED
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<DATA_CTRL>
								FORMULA='toXMLName (\n  contextElement.value.toQName(),\n  rootElement\n)'
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
	<FOLDER>
		MATCHING_ET='xs:simpleType'
		FMT={
			sec.outputStyle='table';
			sec.page.keepTogether='true';
			table.sizing='Relative';
			table.cellpadding.both='0';
			table.bkgr.color='#F5F5F5';
			table.border.style='solid';
			table.border.color='#999999';
			table.border.horz.style='none';
			table.border.vert.style='none';
			table.option.borderStylesInHTML='true';
		}
		SS_NAME='simpleType Rep'
		<BODY>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEMPLATE_CALL_CTRL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='17.3';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.top='4';
									tcell.padding.extra.bottom='4';
									text.style='cs2';
								}
								TEMPLATE_FILE='simpleContentRep.tpl'
								PASSED_PARAMS={
									'abbreviate_enum','getBooleanParam("abbreviateSimpleContent")';
								}
							</TEMPLATE_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
		<HEADER>
			<AREA_SEC>
				COND='getBooleanParam("showHeading")'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<LABEL>
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='17.3';
									tcell.padding.extra.left='4';
									tcell.padding.extra.right='4';
									tcell.padding.extra.top='4';
									par.style='s2';
								}
								TEXT='Simple Content Model'
							</LABEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
	</FOLDER>
</STOCK_SECTIONS>
CHECKSUM='zrPtb9l+gl1Pl?yIftwwb2MSvp7r7Yf0JYkii0c51OU'
</DOCFLEX_TEMPLATE>